<?php

class KT_WPFOMO_Helper {
	/**
	 * @since 1.0.0
	 * @var object $api_instance
	 * @access private
	 */
	static private $api_instance = null;

	/**
	 * Get an instance of the API.
	 *
	 * @since 1.0.0
	 * @param string $api_key A valid API key.
	 * @return object The API instance.
	 */
	static public function get_api( $api_key )
	{
		if ( self::$api_instance ) {
			return self::$api_instance;
		}
		if ( ! class_exists( 'KlicktippConnector' ) ) {
			require_once KT_WPFOMO_DIR . '/inc/klicktipp.api.inc';
		}

		//self::$api_instance = new Mailchimp( $api_key );

		return self::$api_instance;
	}


	static function connect_api() {
		if ( ! class_exists( 'KlicktippConnector' ) ) {
			require_once KT_WPFOMO_DIR . '/inc/klicktipp.api.inc';
		}

		$settings =get_option('ibx_wpfomo_settings');
		$connector = new KlicktippConnector();
		$logged_in = $connector->login( $settings['kt_username'], $settings['kt_password'] );
		if ( ! $logged_in ) {
			return array( 'error'=>$connector->get_last_error() );
		} else {
			return array( 'success' => $connector );
		}
	}

  static function get_fields(){
	$kt_fields = get_transient( 'kt_fields' );

	if ( ! empty( $kt_fields ) ) {
		return $kt_fields;
	}else {

		$connection = self::connect_api();
		$message = '';
		if ( ! isset( $connection['success'] ) ) {
			$fields =   array( $connection['error'] );
		} else {
			$connector = $connection['success'];

			$fields = $connector->field_index();

			if ( ! $fields ) {
				$fields = array( $connector->get_last_error() );
			}
			$extra_fields = array(
				'email'=>'Email',
				//'smsnumber' =>'SMS-Mobilnummmer'
			);
			$fields = $extra_fields+$fields;
		}
		set_transient( 'kt_fields', $fields, 60 * 60 * 60 );
		return $fields;
	}
  }

    static public function get_subscriber( $id )
    {
		$connection = self::connect_api();
		$message = '';
		if ( ! isset( $connection['success'] ) ) {
			$fields =   array( $connection['error'] );
		} else {
			$connector = $connection['success'];

			$subscriber = $connector->subscriber_get(38259018);
			//echo '<pre>';var_dump($subscriber);die;
		}


        // $response = array(
		// 	'error'      => false,
		// 	'members'    => array()
		// );

        // // Make sure we have an API key.
		// if ( empty( $api_key ) ) {
		// 	$response['error'] = __( 'Error: You must provide an API key.', 'ibx-wpfomo' );
		// }

        // // Make sure we have list id.
		// if ( empty( $list_id ) ) {
		// 	$response['error'] = __( 'Error: You must provide a list ID.', 'ibx-wpfomo' );
		// }

        // if ( ! $response['error'] ) {
        //     $api = self::get_api( $api_key );

        //     try {
        //         $members = $api->lists->members( $list_id, 'subscribed', array( 'limit' => $limit, 'sort_field' => 'optin_time', 'sort_dir' => 'DESC' ) );
        //         $response['members'] = $members;
        //     }
        //     catch ( Mailchimp_HttpError $e ) {
        //         $response['error'] = $e->getMessage();
        //     }
        // }

        return $response;
    }
}
