<?php

class KT_Wpfomo_Integration_license_Updater {

	function __construct() {
		add_filter( 'admin_init', array( $this, 'activate_license' ),100 );
		add_action( 'admin_notices',  array( $this, 'admin_notices' ) );
		add_action( 'admin_init', array( $this, 'include_updater' ) );
		add_action( 'admin_init', array( $this, 'check_license' ) );

	}


	public static function include_updater() {
		$settings = get_option( 'ibx_wpfomo_settings' );
		$settings['kt_license_key'] = isset( $settings['kt_license_key'] )?$settings['kt_license_key'] : '';
		if ( !empty( $settings['kt_license_key'] ) ) {
			// setup the updater
			$edd_updater = new EDD_SL_Plugin_Updater( KT_WPFOMO_INTEGRATION_STORE_URL, KT_WPFOMO_INTEGRATION_PLUGIN_FILE, array(
					'version'  => KT_WPFOMO_INTEGRATION_VERSION,
					'license'  => $settings['kt_license_key'],
					'item_id' => KT_WPFOMO_INTEGRATION_ITEM_ID,
					'author'  => 'Thomas'
				)
			);
		}

	}



	function activate_license() {

		// listen for our activate button to be clicked
		//if ( isset( $_POST['kt_integrations_license_input'] ) ) {

		//	var_dump($settings['kt_license_key']); die;
		//	$settings = get_option( 'ibx_wpfomo_settings' );
		            // Save license.
				//	if ( isset( $_POST['ibx_wpfomo_license_key'] ) ) {
			if ( !empty( $_POST['ibx_wpfomo_kt_license_key'] ) ){
				//var_dump($_POST['ibx_wpfomo_kt_license_key']); die;
					// data to send in our API request
					$api_params = array(
						'edd_action' => 'activate_license',
						'license'    => $_POST['ibx_wpfomo_kt_license_key'],
						'item_id'  => urlencode(KT_WPFOMO_INTEGRATION_ITEM_ID ),
						'url'        => home_url()
					);

					// Call the custom API.
					$response = wp_remote_post( KT_WPFOMO_INTEGRATION_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

					// make sure the response came back okay
					if ( is_wp_error( $response ) || 200 !== wp_remote_retrieve_response_code( $response ) ) {

						if ( is_wp_error( $response ) ) {
							$message = $response->get_error_message();
						} else {
							$message = __( 'An error occurred, please try again.' );
						}

					} else {

						$license_data = json_decode( wp_remote_retrieve_body( $response ) );

						if ( false === $license_data->success ) {

							switch ( $license_data->error ) {

							case 'expired' :

								$message = sprintf(
									__( 'Your license key expired on %s.' ),
									date_i18n( get_option( 'date_format' ), strtotime( $license_data->expires, current_time( 'timestamp' ) ) )
								);
								break;

							case 'revoked' :

								$message = __( 'Your license key has been disabled.' );
								break;

							case 'missing' :

								$message = __( 'Invalid Klick Tipp Wpfomify license Key.' );
								break;

							case 'invalid' :
							case 'site_inactive' :

								$message = __( 'Your license is not active for this URL.' );
								break;

							case 'item_name_mismatch' :

								$message = __( 'This appears to be an invalid license key for Klick Tipp Integration.' ) ;
								break;

							case 'no_activations_left':

								$message = __( 'Your license key has reached its activation limit.' );
								break;

							default :

								$message = __( 'An error occurred, please try again.' );
								break;
							}

						}

					}

					// Check if anything passed on a message constituting a failure
					if ( ! empty( $message ) ) {
						$base_url = admin_url( 'edit.php?post_type=ibx_wpfomo&page=wpfomo-settings' );
						$redirect = add_query_arg( array( 'sl_wpfomify_activation' => 'false', 'message' => urlencode( $message ) ), $base_url );

						wp_redirect( $redirect );
						exit();
					}

					// $license_data->license will be either "valid" or "invalid"

					update_option( 'kt_wpfomo_license_status', $license_data->license );
					wp_redirect( admin_url( 'edit.php?post_type=ibx_wpfomo&page=wpfomo-settings' ) );
					exit();
				}

			//}
		}

		public  function check_license() {
			$license_status = get_transient( 'kt_wpfomo_license_status' );
			if ( !$license_status ) {
				// check license

				$settings = get_option( 'ibx_wpfomo_settings' );
				if ( !empty( $settings['kt_license_key'] ) ) {
					$api_params = array(
						'edd_action'=> 'check_license',
						'license'  => $settings['kt_license_key'],
						'item_id' => urlencode( KT_WPFOMO_INTEGRATION_ITEM_ID ),
						'url' => home_url()
					);
					// Call the custom API.
					$response = wp_remote_get( add_query_arg( $api_params, KT_WPFOMO_INTEGRATION_STORE_URL ), array( 'timeout' => 15, 'sslverify' => false ) );

					// make sure the response came back okay
					if ( is_wp_error( $response ) )
					return false;

					// decode the license data
					$license_data = json_decode( wp_remote_retrieve_body( $response ) );

					// $license_data->license will be either "active" or "inactive"

					update_option( 'kt_wpfomo_license_status', $license_data->license );
					set_transient( 'kt_wpfomo_license_status', $license_data->license, 60 * 60 * 24 );
				}
			}

		}


		function admin_notices() {
			if ( isset( $_GET['sl_wpfomify_activation'] ) && ! empty( $_GET['message'] ) ) {

				switch ( $_GET['sl_wpfomify_activation'] ) {

				case 'false':
					$message = urldecode( $_GET['message'] );
?>
				<div class="error">
					<p><?php echo $message; ?></p>
				</div>
				<?php
					break;

				case 'true':
				default:
					// Developers can put a custom success message here for when activation is successful if they way.
					break;

				}
			}
		}
	}

	new KT_Wpfomo_Integration_license_Updater();




